// Author: A.Voss@FH-Aachen.de
//
// usage of references (&) instead of pointers (*)
// tags: references

#include <iostream>
#include <cstdlib>
#include <string>
using namespace std;

#include "../../include/tools.h"

void swap1(double d1, double d2)
{
    double d = d1;
    d1 = d2;
    d2 = d;
}

void swap2(double *pd1, double *pd2)
{
    double d = *pd1;
    *pd1 = *pd2;
    *pd2 = d;
}

void swap3(double &d1, double &d2)
{
    double d = d1;
    d1 = d2;
    d2 = d;
}

int main()
{
    double d1 = 2.1, d2 = 3.4;
    
    tools_log(); cout << "orig.: d1 = " << d1 << ", d2 = " << d2 << endl;
    
    swap1(d1,d2);

    tools_log(); cout << "after swap1: d1 = " << d1 << ", d2 = " << d2 << endl;
    
    swap2(&d1,&d2);

    tools_log(); cout << "after swap2: d1 = " << d1 << ", d2 = " << d2 << endl;
    
    swap3(d1,d2);

    tools_log(); cout << "after swap3: d1 = " << d1 << ", d2 = " << d2 << endl;
    
    return EXIT_SUCCESS;
}

