// Author: A.Voss@FH-Aachen.de
//
// formatted output
// tags: cout, cin, width, precision, fill, setf, left, right

#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <string>
using namespace std;

#include "../../include/tools.h"

int main()
{
    double d;
    int n;
    
    d = 12.34567;
    tools_log(); 
    cout << "|";
    cout.width(10);      // sets _next_ output to width of (min) 6 
    cout << d;
    cout << "|" << d << "|" << endl;

    tools_log(); 
    cout << "|";
    cout.width(3);      // means a minimum of 3, here the number d does not fit ...
    cout << d << "|" << endl;
    
    // some flags are forever ... e.g. precision
    tools_log(); 
    cout << "|";
    cout.precision(3);
    cout << d << "|" << endl;
  
    // ... or fill char
    n = 17;
    tools_log(); 
    cout << "|";
    cout.fill('x');
    cout.width(10);
    cout << n << "|";
    cout.width(10);
    cout << n << "|" << endl;
    
    // ... or hex / dec
    tools_log(); 
    cout << "|";
    cout.width(10);
    cout.setf(ios::hex,ios::basefield);     // clear other flags
    cout << n << "|";
    cout.width(10);
    cout.setf(ios::left,ios::adjustfield);
    cout << n << "|" << endl;

    // reset  
    cout.fill(' ');        
    cout.setf(ios::dec,ios::basefield);
    cout.setf(ios::right,ios::adjustfield);
    cout.precision(6);

    tools_log(); 
    cout << "|" << d << "|" << endl;

    // set-functions often return old value, e.g. char OldChar = cout.fill(' ');  

    // a more convenient setting uses manipulators
    
    tools_log(); 
    cout << "|" << setw(10) << left << setfill('.') << d << "|" << setw(10) << d << "|" << endl;
    
    string s = "Hello!";
    tools_log(); 
    cout << "|" << setw(10) << right << s << "|" << endl;
 
    return EXIT_SUCCESS;
}

